<?php
/*	wp_import : WordPressインポート
	name : WordPressインポート
	author: team1/3
	WirdPressのxmlファイルをインポートする
*/

	global $html,$params,$database,$config,$ut,$plugin_ar;

	if (!isset($config)) { die(); }
	
	draw();
	
	$params['rendering'] = false;

function draw()
{
	global $html,$params,$database,$ut;
	
	$page_ar = &$params['page'];
	$p_page = $page_ar['id'];

	if (check_rights('owner')) {
		set_func_right('edit.modules');
		set_func_right('add_page');
		provide_edit_rights();
		provide_edit_module();
	}

	if (isset($_GET['mode']) && $_GET['mode'] == 'edit') {
		// 編集
		provide_edit_module();
		unset($params['breadcrumb']);
		snippet_breadcrumb($p_page, 'Page Edit');
		$buff = page_edit_renderer($page_ar);
		$html['article'][] = frame_renderer($buff);
		return;

	} else {
		// 通常表示
		snippet_breadcrumb($page_ar['link'], $page_ar['title']);
		write_wp_import($page_ar);
	}
}

function write_wp_import( &$page_ar )
{
	global $params, $ut, $html, $database, $plugin_ar;

	$id = $page_ar['id'];
	//$parent_page = $page_ar['id'];		//自ページが親ページ

	
	$ar = $database->sql_select_all("select id,metadata from ".DBX."data_items where type=? and id=? ", $page_ar['type'], $id);
	if ($ar) {
		$m = unserialize64($ar[0]['metadata']);
	}

	$html['article'][] = frame_renderer(body_renderer($page_ar));	// 通常ページ部分

	//$arg = array('id'=>$parent_page);
	$buff = my_wp_import($arg);
	
	$html['article'][] = frame_renderer($buff,'wp_import-unit');

	if (!isset($html['head']['wp_import'])) {
$html['head']['wp_import'] = <<<EOT
		<style>
		</style>
EOT;
	}

	
	$html['article'][] = innerpage_renderer($page_ar);

	return;
}


function my_wp_import( &$arg )
{
	global $params, $ut, $database, $html;


	$buff = '';
	if (check_rights('edit')) {
$buff .= <<<EOT
		<form method="post" enctype='multipart/form-data' action="{$_SERVER['REQUEST_URI']}">
			<table class='onethird-setting'>
				<tr>
					<td style='vertical-align: top;'>WordPress File</td>
					<td>
						<input type='file' name='wp_import_file' />
						<input type='submit' value='import' name='import' />
						<input type='submit' value='delete' name='delete' class='mini' />
						<input type='hidden' name='xtoken' value='{$params['login_user']['meta']['magic_str']}' />
					</td>
				</tr>
			</table>
		</form>
EOT;
		if (!empty($_POST['delete'])) {
			
			$link = $params['page']['link'];
			$ar = array();
			get_linked_pages( $params['page']['id'], $ar );
			array_shift($ar);
			if (!remove_pages($ar)) {
				return false;
			}
			regenerate_attached( $params['page']['id'], true );

		} else if (!empty($_FILES['wp_import_file'])) {
			$file1 = $_FILES['wp_import_file'];

			$file1tmp   = $_FILES['wp_import_file']['tmp_name'];		//tmpファイル名
			$file1name  = $_FILES['wp_import_file']['name'];			//ローカルファイル名
			$file1size  = $_FILES['wp_import_file']['size'];			//ファイルサイズ
			$file1type  = $_FILES['wp_import_file']['type'];			//ファイルの種類
			
			$info = pathinfo($file1name);

			if (is_uploaded_file($file1tmp)) {
				$xml = @simplexml_load_file($file1tmp,'SimpleXMLElement',LIBXML_NOCDATA);
				if ($xml) {
					$database->sql_begin();
					//カテゴリーの読み込み
					$max_post_id = 0;
					$category_ar = array();
					foreach ($xml->channel->item as $v) {
						$post_id = safe_echo((string)$v->children('wp',true)->post_id);
						if ($post_id > $max_post_id) {
							$max_post_id = $post_id;
						}
						foreach ($v->category as $vv) {
							if ($vv['domain'] == 'category') {
								$category_ar[safe_echo((string)$vv)] = true;
							}
						}
					}
					//カテゴリーページ作成
					foreach ($category_ar as $k => &$v) {
						$ar = $database->sql_select_all("select metadata from ".DBX."data_items where link=? and title=?", $params['page']['id'], $k);
						if ($ar && $ar[0]) {
							$m = unserialize64($ar[0]['metadata']);
							if (empty($m['wp_import'])) {
								$buff .= "error #{$post_id} - ".__LINE__."<br />";
							}
						} else {
							$r['type'] = PAGE_FOLDER_ID;
							$r['title'] = $k;
							$r['block_type'] = 1;
							$r['mode'] = 1;
							$r['meta']['wp_import'] = true;
							$r['link'] = $params['page']['id'];
							
							if (create_page( $r )) {
								$v = $r['id'];
								if ($r < $max_post_id) {
									++$max_post_id;
									if (!$database->sql_update("update ".DBX."data_items set id=? where id=? ", $max_post_id, $r['id'])) {
										$buff .= "error #{$post_id} - ".__LINE__."<br />";
									} else {
										$v = $max_post_id;
										regenerate_attached($max_post_id);
									}
								}
								$r['metadata'] = serialize64($r['meta']);
								mod_data_items($r);
							} else {
								$buff .= "error #{$post_id} - ".__LINE__."<br />";
							}
						}
					}
					unset($v);
					//各ページ作成
					foreach ($xml->channel->item as $v) {
						$x = array();
						$title = safe_echo((string)$v->title);
						$link = $params['page']['id'];
						$x['link'] = safe_echo((string)$v->title);
						$x['pubDate'] = safe_echo((string)$v->title);
						$x['guid'] = safe_echo((string)$v->guid);
						$x['description'] = safe_echo((string)$v->description);
						$x['creator'] = safe_echo((string)$v->children('dc',true)->creator);
						$contents = sanitize_html((string)$v->children('content',true)->encoded);
						//$x['excerpt_encoded'] = safe_echo((string)$v->children('excerpt',true)->encoded);
						$post_id = $x['post_id'] = safe_echo((string)$v->children('wp',true)->post_id);
						$mod_date = safe_echo((string)$v->children('wp',true)->post_date);
						$x['post_date_gmt'] = safe_echo((string)$v->children('wp',true)->post_date_gmt);
						$x['comment_status'] = safe_echo((string)$v->children('wp',true)->comment_status);
						$x['ping_status'] = safe_echo((string)$v->children('wp',true)->ping_status);
						$x['post_name'] = safe_echo((string)$v->children('wp',true)->post_name);
						$x['status'] = safe_echo((string)$v->children('wp',true)->status);
						$x['post_parent'] = safe_echo((string)$v->children('wp',true)->post_parent);
						$x['menu_order'] = safe_echo((string)$v->children('wp',true)->menu_order);
						$x['post_type'] = safe_echo((string)$v->children('wp',true)->post_type);
						$x['post_password'] = safe_echo((string)$v->children('wp',true)->post_password);
						$x['is_sticky'] = safe_echo((string)$v->children('wp',true)->is_sticky);
						$x['attachment_url'] = safe_echo((string)$v->children('wp',true)->attachment_url);
						$postmeta = $v->children('wp',true)->postmeta;
						$x['meta_data'] = array();
						$attached = false;
						foreach ($postmeta as $vv) {
							$xk = safe_echo((string)$vv->children('wp',true)->meta_key);
							$xv = safe_echo((string)$vv->children('wp',true)->meta_value);
							$x['meta_data'][$xk] = $xv;
							if ($xk == '_wp_attached_file') {
								$attached = true;
							}
						}
						$tag = '';
						foreach ($v->category as $vv) {
							if ($tag) { $tag .= ','; }
							$k = safe_echo((string)$vv);
							if ($k) {
								if ($vv['domain'] == 'category') {
									if (!empty($category_ar[$k])) {
										$link = $category_ar[$k];
									}
								} else {
									$tag .= $k;
								}
							}
						}
						//
						if (!$attached) {
							$r = array();
							//$r['type'] = 1;
							$r['type'] = TOPIC_ITEM_ID;
							$contents = str_replace("\n","<br />",$contents);
							$r['contents'] = $contents;
							$r['mod_date'] = $mod_date;
							$r['title'] = $title;
							$tag = trim($tag, ', ');
							if ($tag) {
								$r['tag'] = "#{$tag},";
							} else {
								$r['tag'] = "";
							}
							$r['meta'] = $x;
							$r['meta']['wp_import'] = true;
							$r['link'] = $link;
							if ($x['status'] == 'publish') {
								$r['mode'] = 1;
							}
							$ar = $database->sql_select_all("select metadata from ".DBX."data_items where id=? ", $post_id);
							if ($ar && $ar[0]) {
								$m = unserialize64($ar[0]['metadata']);
								if (!empty($m['wp_import'])) {
									$r['id'] = $post_id;
									if (!mod_data_items($r)) {
										$buff .= "error #{$post_id} - ".__LINE__."<br />";
									}
								} else {
									$buff .= "error #{$post_id} - ".__LINE__."<br />";
								}
							} else {
								if (create_page( $r )) {
									if (!$database->sql_update("update ".DBX."data_items set id=? where id=? ", $post_id, $r['id'])) {
										$buff .= "error #{$post_id} - ".__LINE__."<br />";
									}
									regenerate_attached($post_id);
								} else {
									$buff .= "error #{$post_id} - ".__LINE__."<br />";
								}
							}
						}
					}
					$database->sql_commit();
				}
			}
		}
	}

	// 表示
	$option = array();
	$option['total'] = 0;
	$option['offset'] = 0;
	$option['page_size'] = 30;
	$mode = '';

	if (isset($_GET['get_ajax']) && $_GET['get_ajax'] == 'plugin_page_folder_read')  {
		$arg['id'] = (int)$_GET['link'];
		if (isset($_GET['offset'])) {
			$option['offset'] = (int)$_GET['offset'];
		}
		$mode = ($_GET['mode'] == 'more') ? 'more': 'open';
	}

	$type = 0;
	$offset_name = 'offset';
	$id = $params['page']['id'];
	$more = false;
	if (isset($arg['id'])) {
		$id = $arg['id'];
	}
	if (isset($arg['type'])) {
		$type = $arg['type'];
	}
	if (isset($arg['more'])) {
		$more = true;
	}
	if (isset($arg['offset_name'])) {
		$offset_name = $arg['offset_name'];
	}
	$option['offset_name'] = $offset_name;
	
	$opt = ' and mode<>2 ';
	if (!check_rights()) {
		$opt = ' and mode=1 ';
	} else if (!check_rights()) {
		$opt = ' and (mode=1 or (mode=0 and user='.(int)($_SESSION['login_id']).' ';
	}

	$ar = $database->sql_select_all("select count(id) as c from ".DBX."data_items where link=? and block_type !=5 $opt", $id);
	if ($ar) {
		$option['total'] = $ar[0]['c'];
	}
	if (isset($_GET[$offset_name])) {
		$option['offset'] = (int)$_GET[$offset_name];
	}
	if (isset($arg['page_size'])) {
		$option['page_size'] = (int)$arg['page_size'];
	}

	if (!isset($arg['order']) || $arg['order'] == 'desc') {
		$order = 'order by date desc';
	} else {
		$order = 'order by date asc';
	}
	
	// write foloder
	$sql = "select id,type,metadata,title,mode,user,date from ".DBX."data_items ";
	$sql .= " where link=? and block_type !=5";
	$sql .= " and type=".PAGE_FOLDER_ID;
	$sql .= " $opt $order";
	$folder_ar = $database->sql_select_all($sql, $id);

	// write page
	$sql = "select id,type,metadata,title,mode,user,date from ".DBX."data_items ";
	$sql .= " where link=? and block_type !=5";
	if ($type) {
		$sql .= " and type={$type} ";
	} else {
		$sql .= " and type <>".PAGE_FOLDER_ID;
	}
	$sql .= " $opt $order";
	$sql .= " {$ut->limit($option['offset']*$option['page_size'], $option['page_size'])} ";
	
	$ar = $database->sql_select_all($sql, $id);
	$c = count($ar);
	if (!isset($arg['writer'])) {
		if (isset($plugin_ar[ PAGE_FOLDER_ID ]['writer'])) {
			reset($plugin_ar[ PAGE_FOLDER_ID ]['writer']);
			$arg['writer'] = key($plugin_ar[ PAGE_FOLDER_ID ]['writer']);
		} else {
			$arg['writer'] = 'my_wp_import_writer';
		}
	}
	if ($mode != 'more') {
		$ar = array_merge($folder_ar,$ar);
	}
	$buff .= $arg['writer']($ar);
	
	if ($more) {
		if ($c >0 && $c == $option['page_size']) {
			$ofs = $option['offset']+1;
			$buff .= "<p id='plugin_page_folder_more{$id}'><a href='javascript:void(plugin_page_folder_read($id,\"more\",{$ofs}))'>more...</a></p>";
		}
	} else {
		$buff = std_pagination_renderer( $option ).$buff;
	}

	if ($more) {
$html['meta']['page_folder'] = <<<EOT
		<script>
		plugin_page_folder_read = function (link,md,ofs) {
			if (\$('#plugin_page_folder'+link+' .open_hnd').length) {
				\$('#plugin_page_folder'+link+' .open_hnd').toggle();
				return;
			}
			var opt = '';
			opt += "&link="+link;
			if (md) { opt += "&mode="+md; }
			if (ofs) { opt += "&offset="+ofs; }
			\$.ajax({
				type: "POST"
				, url: "{$ut->link($params['page']['id'],'&:get_ajax=plugin_page_folder_read')}"+opt
				, dataType:'json'
				, success: function(data){
					if ( data ) {
						if (data['mode'] == 'open') {
							var a = "<div class='open_hnd' style='padding-left:20px;'>"+data['html']+"</div>";
							\$('#plugin_page_folder'+data['id']).append(a);
						} else {
							\$('#plugin_page_folder_more'+data['id']).after(data['html']).remove();
						}
					}
				}
			});
		};
		</script>
EOT;
	}

	if (isset($_GET['get_ajax']) && $_GET['get_ajax'] == 'plugin_page_folder_read')  {
		$r = array();
		$r['id'] = $id;
		$r['mode'] = $mode;
		$r['url'] = $ut->link($id);
		$r['html'] = $buff;
		$r['ar'] = $ar;
		echo( json_encode($r) );
		exit();
	}

	return $buff;
}

function my_wp_import_writer( &$ar )
{
	global $ut,$html,$config,$params;

	$buff = '';
	$nt = time();
	foreach ($ar as $v) {
		$t = $v['title'];
		$ico = '';
		if (!$t) { $t = '...'; }
		$u = $ut->link($v['id']);
		if ($v['type'] == PAGE_FOLDER_ID) {
			$ico = $ut->icon('folder',"width='16'");
		}
		if ($v['mode'] == 0) {
			if (!check_rights('edit') && isset($_SESSION['login_id']) && $v['user'] != $_SESSION['login_id']) { continue; }
			$t = $t.$ut->icon('lock','width="16"');
		}
		$d = substr($v['date'],0,10);
$buff .= <<<EOT
		<p id='plugin_wp_import{$v['id']}' >
			{$ico} <a href='{$ut->link($v['id'])}'>{$t}</a> <span class='date'>{$d}</span>
		</p>
EOT;
	}

	return $buff;
}


?>